/*
 * Copyright 2010 Linaro
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation.
 *
 * Authored by: Jammy Zhou <jammy.zhou@linaro.org>
 *
 */
#include <stdlib.h>

#include <GL/gl_proxy.h>
#include <GL/glext_proxy.h>

/* proxy functions for GLES2 extensions */
PFNPROXYEGLIMAGETARGETTEXTURE2DOESPROC pfnProxyEGLImageTargetTexture2DOES = NULL;
PFNPROXYEGLIMAGETARGETRENDERBUFFERSTORAGEOESPROC pfnProxyEGLImageTargetRenderbufferStorageOES = NULL;
PFNPROXYGETPROGRAMBINARYOESPROC pfnProxyGetProgramBinaryOES = NULL;
PFNPROXYPROGRAMBINARYOESPROC pfnProxyProgramBinaryOES = NULL;
PFNPROXYMAPBUFFEROESPROC pfnProxyMapBufferOES = NULL;
PFNPROXYUNMAPBUFFEROESPROC pfnProxyUnmapBufferOES = NULL;
PFNPROXYGETBUFFERPOINTERVOESPROC pfnProxyGetBufferPointervOES = NULL;
PFNPROXYTEXIMAGE3DOESPROC pfnProxyTexImage3DOES = NULL;
PFNPROXYTEXSUBIMAGE3DOESPROC pfnProxyTexSubImage3DOES = NULL;
PFNPROXYCOPYTEXSUBIMAGE3DOESPROC pfnProxyCopyTexSubImage3DOES = NULL;
PFNPROXYCOMPRESSEDTEXIMAGE3DOESPROC pfnProxyCompressedTexImage3DOES = NULL;
PFNPROXYCOMPRESSEDTEXSUBIMAGE3DOESPROC pfnProxyCompressedTexSubImage3DOES = NULL;
PFNPROXYFRAMEBUFFERTEXTURE3DOESPROC pfnProxyFramebufferTexture3DOES = NULL;
PFNPROXYBINDVERTEXARRAYOESPROC pfnProxyBindVertexArrayOES = NULL;
PFNPROXYDELETEVERTEXARRAYSOESPROC pfnProxyDeleteVertexArraysOES = NULL;
PFNPROXYGENVERTEXARRAYSOESPROC pfnProxyGenVertexArraysOES = NULL;
PFNPROXYISVERTEXARRAYOESPROC pfnProxyIsVertexArrayOES = NULL;
PFNPROXYGETPERFMONITORGROUPSAMDPROC pfnProxyGetPerfMonitorGroupsAMD = NULL;
PFNPROXYGETPERFMONITORCOUNTERSAMDPROC pfnProxyGetPerfMonitorCountersAMD = NULL;
PFNPROXYGETPERFMONITORGROUPSTRINGAMDPROC pfnProxyGetPerfMonitorGroupStringAMD = NULL;
PFNPROXYGETPERFMONITORCOUNTERSTRINGAMDPROC pfnProxyGetPerfMonitorCounterStringAMD = NULL;
PFNPROXYGETPERFMONITORCOUNTERINFOAMDPROC pfnProxyGetPerfMonitorCounterInfoAMD = NULL;
PFNPROXYGENPERFMONITORSAMDPROC pfnProxyGenPerfMonitorsAMD = NULL;
PFNPROXYDELETEPERFMONITORSAMDPROC pfnProxyDeletePerfMonitorsAMD = NULL;
PFNPROXYSELECTPERFMONITORCOUNTERSAMDPROC pfnProxySelectPerfMonitorCountersAMD = NULL;
PFNPROXYBEGINPERFMONITORAMDPROC pfnProxyBeginPerfMonitorAMD = NULL;
PFNPROXYENDPERFMONITORAMDPROC pfnProxyEndPerfMonitorAMD = NULL;
PFNPROXYGETPERFMONITORCOUNTERDATAAMDPROC pfnProxyGetPerfMonitorCounterDataAMD = NULL;
PFNPROXYDISCARDFRAMEBUFFEREXTPROC pfnProxyDiscardFramebufferEXT = NULL;
PFNPROXYMULTIDRAWARRAYSEXTPROC pfnProxyMultiDrawArraysEXT = NULL;
PFNPROXYMULTIDRAWELEMENTSEXTPROC pfnProxyMultiDrawElementsEXT = NULL;
PFNPROXYRENDERBUFFERSTORAGEMULTISAMPLEIMGPROC pfnProxyRenderbufferStorageMultisampleIMG = NULL;
PFNPROXYFRAMEBUFFERTEXTURE2DMULTISAMPLEIMGPROC pfnProxyFramebufferTexture2DMultisampleIMG = NULL;
PFNPROXYDELETEFENCESNVPROC pfnProxyDeleteFencesNV = NULL;
PFNPROXYGENFENCESNVPROC pfnProxyGenFencesNV = NULL;
PFNPROXYISFENCENVPROC pfnProxyIsFenceNV = NULL;
PFNPROXYTESTFENCENVPROC pfnProxyTestFenceNV = NULL;
PFNPROXYGETFENCEIVNVPROC pfnProxyGetFenceivNV = NULL;
PFNPROXYFINISHFENCENVPROC pfnProxyFinishFenceNV = NULL;
PFNPROXYSETFENCENVPROC pfnProxySetFenceNV = NULL;
PFNPROXYCOVERAGEMASKNVPROC pfnProxyCoverageMaskNV = NULL;
PFNPROXYCOVERAGEOPERATIONNVPROC pfnProxyCoverageOperationNV = NULL;
PFNPROXYGETDRIVERCONTROLSQCOMPROC pfnProxyGetDriverControlsQCOM = NULL;
PFNPROXYGETDRIVERCONTROLSTRINGQCOMPROC pfnProxyGetDriverControlStringQCOM = NULL;
PFNPROXYENABLEDRIVERCONTROLQCOMPROC pfnProxyEnableDriverControlQCOM = NULL;
PFNPROXYDISABLEDRIVERCONTROLQCOMPROC pfnProxyDisableDriverControlQCOM = NULL;
PFNPROXYEXTGETTEXTURESQCOMPROC pfnProxyExtGetTexturesQCOM = NULL;
PFNPROXYEXTGETBUFFERSQCOMPROC pfnProxyExtGetBuffersQCOM = NULL;
PFNPROXYEXTGETRENDERBUFFERSQCOMPROC pfnProxyExtGetRenderbuffersQCOM = NULL;
PFNPROXYEXTGETFRAMEBUFFERSQCOMPROC pfnProxyExtGetFramebuffersQCOM = NULL;
PFNPROXYEXTGETTEXLEVELPARAMETERIVQCOMPROC pfnProxyExtGetTexLevelParameterivQCOM = NULL;
PFNPROXYEXTTEXOBJECTSTATEOVERRIDEIQCOMPROC pfnProxyExtTexObjectStateOverrideiQCOM = NULL;
PFNPROXYEXTGETTEXSUBIMAGEQCOMPROC pfnProxyExtGetTexSubImageQCOM = NULL;
PFNPROXYEXTGETBUFFERPOINTERVQCOMPROC pfnProxyExtGetBufferPointervQCOM = NULL;
PFNPROXYEXTGETSHADERSQCOMPROC pfnProxyExtGetShadersQCOM = NULL;
PFNPROXYEXTGETPROGRAMSQCOMPROC pfnProxyExtGetProgramsQCOM = NULL;
PFNPROXYEXTISPROGRAMBINARYQCOMPROC pfnProxyExtIsProgramBinaryQCOM = NULL;
PFNPROXYEXTGETPROGRAMBINARYSOURCEQCOMPROC pfnProxyExtGetProgramBinarySourceQCOM = NULL;
PFNPROXYSTARTTILINGQCOMPROC pfnProxyStartTilingQCOM = NULL;
PFNPROXYENDTILINGQCOMPROC pfnProxyEndTilingQCOM = NULL;

/* Symbol resolve */
extern void *glProxyGetProcAddr(void *handle, const char *name);

int glProxyExtInitGLES2(void *handle)
{
	if (NULL == handle) {
		return -1;
	}

	pfnProxyEGLImageTargetTexture2DOES = glProxyGetProcAddr(handle, "glEGLImageTargetTexture2DOES");
	pfnProxyEGLImageTargetRenderbufferStorageOES = glProxyGetProcAddr(handle, "glEGLImageTargetRenderbufferStorageOES");
	pfnProxyGetProgramBinaryOES = glProxyGetProcAddr(handle, "glGetProgramBinaryOES");
	pfnProxyProgramBinaryOES = glProxyGetProcAddr(handle, "glProgramBinaryOES");
	pfnProxyMapBufferOES = glProxyGetProcAddr(handle, "glMapBufferOES");
	pfnProxyUnmapBufferOES = glProxyGetProcAddr(handle, "glUnmapBufferOES");
	pfnProxyGetBufferPointervOES = glProxyGetProcAddr(handle, "glGetBufferPointervOES");
	pfnProxyTexImage3DOES = glProxyGetProcAddr(handle, "glTexImage3DOES");
	pfnProxyTexSubImage3DOES = glProxyGetProcAddr(handle, "glTexSubImage3DOES");
	pfnProxyCopyTexSubImage3DOES = glProxyGetProcAddr(handle, "glCopyTexSubImage3DOES");
	pfnProxyCompressedTexImage3DOES = glProxyGetProcAddr(handle, "glCompressedTexImage3DOES");
	pfnProxyCompressedTexSubImage3DOES = glProxyGetProcAddr(handle, "glCompressedTexSubImage3DOES");
	pfnProxyFramebufferTexture3DOES = glProxyGetProcAddr(handle, "glFramebufferTexture3DOES");
	pfnProxyBindVertexArrayOES = glProxyGetProcAddr(handle, "glBindVertexArrayOES");
	pfnProxyDeleteVertexArraysOES = glProxyGetProcAddr(handle, "glDeleteVertexArraysOES");
	pfnProxyGenVertexArraysOES = glProxyGetProcAddr(handle, "glGenVertexArraysOES");
	pfnProxyIsVertexArrayOES = glProxyGetProcAddr(handle, "glIsVertexArrayOES");
	pfnProxyGetPerfMonitorGroupsAMD = glProxyGetProcAddr(handle, "glGetPerfMonitorGroupsAMD");
	pfnProxyGetPerfMonitorCountersAMD = glProxyGetProcAddr(handle, "glGetPerfMonitorCountersAMD");
	pfnProxyGetPerfMonitorGroupStringAMD = glProxyGetProcAddr(handle, "glGetPerfMonitorGroupStringAMD");
	pfnProxyGetPerfMonitorCounterStringAMD = glProxyGetProcAddr(handle, "glGetPerfMonitorCounterStringAMD");
	pfnProxyGetPerfMonitorCounterInfoAMD = glProxyGetProcAddr(handle, "glGetPerfMonitorCounterInfoAMD");
	pfnProxyGenPerfMonitorsAMD = glProxyGetProcAddr(handle, "glGenPerfMonitorsAMD");
	pfnProxyDeletePerfMonitorsAMD = glProxyGetProcAddr(handle, "glDeletePerfMonitorsAMD");
	pfnProxySelectPerfMonitorCountersAMD = glProxyGetProcAddr(handle, "glSelectPerfMonitorCountersAMD");
	pfnProxyBeginPerfMonitorAMD = glProxyGetProcAddr(handle, "glBeginPerfMonitorAMD");
	pfnProxyEndPerfMonitorAMD = glProxyGetProcAddr(handle, "glEndPerfMonitorAMD");
	pfnProxyGetPerfMonitorCounterDataAMD = glProxyGetProcAddr(handle, "glGetPerfMonitorCounterDataAMD");
	pfnProxyDiscardFramebufferEXT = glProxyGetProcAddr(handle, "glDiscardFramebufferEXT");
	pfnProxyMultiDrawArraysEXT = glProxyGetProcAddr(handle, "glMultiDrawArraysEXT");
	pfnProxyMultiDrawElementsEXT = glProxyGetProcAddr(handle, "glMultiDrawElementsEXT");
	pfnProxyRenderbufferStorageMultisampleIMG = glProxyGetProcAddr(handle, "glRenderbufferStorageMultisampleIMG");
	pfnProxyFramebufferTexture2DMultisampleIMG = glProxyGetProcAddr(handle, "glFramebufferTexture2DMultisampleIMG");
	pfnProxyDeleteFencesNV = glProxyGetProcAddr(handle, "glDeleteFencesNV");
	pfnProxyGenFencesNV = glProxyGetProcAddr(handle, "glGenFencesNV");
	pfnProxyIsFenceNV = glProxyGetProcAddr(handle, "glIsFenceNV");
	pfnProxyTestFenceNV = glProxyGetProcAddr(handle, "glTestFenceNV");
	pfnProxyGetFenceivNV = glProxyGetProcAddr(handle, "glGetFenceivNV");
	pfnProxyFinishFenceNV = glProxyGetProcAddr(handle, "glFinishFenceNV");
	pfnProxySetFenceNV = glProxyGetProcAddr(handle, "glSetFenceNV");
	pfnProxyCoverageMaskNV = glProxyGetProcAddr(handle, "glCoverageMaskNV");
	pfnProxyCoverageOperationNV = glProxyGetProcAddr(handle, "glCoverageOperationNV");
	pfnProxyGetDriverControlsQCOM = glProxyGetProcAddr(handle, "glGetDriverControlsQCOM");
	pfnProxyGetDriverControlStringQCOM = glProxyGetProcAddr(handle, "glGetDriverControlStringQCOM");
	pfnProxyEnableDriverControlQCOM = glProxyGetProcAddr(handle, "glEnableDriverControlQCOM");
	pfnProxyDisableDriverControlQCOM = glProxyGetProcAddr(handle, "glDisableDriverControlQCOM");
	pfnProxyExtGetTexturesQCOM = glProxyGetProcAddr(handle, "glExtGetTexturesQCOM");
	pfnProxyExtGetBuffersQCOM = glProxyGetProcAddr(handle, "glExtGetBuffersQCOM");
	pfnProxyExtGetRenderbuffersQCOM = glProxyGetProcAddr(handle, "glExtGetRenderbuffersQCOM");
	pfnProxyExtGetFramebuffersQCOM = glProxyGetProcAddr(handle, "glExtGetFramebuffersQCOM");
	pfnProxyExtGetTexLevelParameterivQCOM = glProxyGetProcAddr(handle, "glExtGetTexLevelParameterivQCOM");
	pfnProxyExtTexObjectStateOverrideiQCOM = glProxyGetProcAddr(handle, "glExtTexObjectStateOverrideiQCOM");
	pfnProxyExtGetTexSubImageQCOM = glProxyGetProcAddr(handle, "glExtGetTexSubImageQCOM");
	pfnProxyExtGetBufferPointervQCOM = glProxyGetProcAddr(handle, "glExtGetBufferPointervQCOM");
	pfnProxyExtGetShadersQCOM = glProxyGetProcAddr(handle, "glExtGetShadersQCOM");
	pfnProxyExtGetProgramsQCOM = glProxyGetProcAddr(handle, "glExtGetProgramsQCOM");
	pfnProxyExtIsProgramBinaryQCOM = glProxyGetProcAddr(handle, "glExtIsProgramBinaryQCOM");
	pfnProxyExtGetProgramBinarySourceQCOM = glProxyGetProcAddr(handle, "glExtGetProgramBinarySourceQCOM");
	pfnProxyStartTilingQCOM = glProxyGetProcAddr(handle, "glStartTilingQCOM");
	pfnProxyEndTilingQCOM = glProxyGetProcAddr(handle, "glEndTilingQCOM");
}

int glProxyExtInitGL(void *handle)
{
	/* TODO */
	return 0;
}
